Bug 1468503 (CVE-2017-10983) - CVE-2017-10983 freeradius: Out-of-bounds read in fr_dhcp_decode() when decoding option 63
Summary: CVE-2017-10983 freeradius: Out-of-bounds read in fr_dhcp_decode() when decodi...
Keywords:
Status: CLOSED ERRATA
Alias: CVE-2017-10983
Product: Security Response
Classification: Other
Component: vulnerability
Version: unspecified
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Red Hat Product Security
QA Contact:
URL:
Whiteboard:
Depends On: 1469126 1469127 1469412 1469413 1471860
Blocks: 1468570
TreeView+ depends on / blocked
 
Reported: 2017-07-07 09:17 UTC by Adam Mariš
Modified: 2019-09-29 14:15 UTC (History)
6 users (show)

Fixed In Version: freeradius 2.2.10, freeradius 3.0.15
Doc Type: If docs needed, set a value
Doc Text:
An out-of-bounds read flaw was found in the way FreeRADIUS server handled decoding of DHCP packets. A remote attacker could use this flaw to crash the FreeRADIUS server by sending a specially crafted DHCP request.
Clone Of:
Environment:
Last Closed: 2017-08-02 09:40:22 UTC


Attachments (Terms of Use)
Proposed patch 1/2 (719 bytes, patch)
2017-07-07 12:11 UTC, Adam Mariš
no flags Details | Diff
Proposed patch 2/2 (995 bytes, patch)
2017-07-07 12:11 UTC, Adam Mariš
no flags Details | Diff


Links
System ID Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2017:1759 normal SHIPPED_LIVE Important: freeradius security update 2017-07-18 07:41:08 UTC
Red Hat Product Errata RHSA-2017:2389 normal SHIPPED_LIVE Important: freeradius security update 2017-08-01 19:45:02 UTC

Description Adam Mariš 2017-07-07 09:17:07 UTC
The fr_dhcp_decode() function performed a strcmp() on binary data in an internal data structure, instead of checking the length of the option and doing a memcmp. The server can read memory until it reaches a zero byte. Depending on memory layout, this read may initiate a page fault, and cause the server to crash.

The security impact is denial of service by any network device capable of sending DHCP packets to FreeRADIUS, which sends a DHCP option 63 with non-zero contents.

Affected versions: 2.0.0 through 3.0.14, inclusive.

Comment 1 Adam Mariš 2017-07-07 09:17:15 UTC
Acknowledgments:

Name: the FreeRADIUS project
Upstream: Guido Vranken

Comment 2 Adam Mariš 2017-07-07 12:11:10 UTC
Created attachment 1295275 [details]
Proposed patch 1/2

Comment 3 Adam Mariš 2017-07-07 12:11:31 UTC
Created attachment 1295276 [details]
Proposed patch 2/2

Comment 10 Dhiru Kholia 2017-07-17 14:35:52 UTC
Created freeradius tracking bugs for this issue:

Affects: fedora-all [bug 1471860]

Comment 11 errata-xmlrpc 2017-07-18 03:42:26 UTC
This issue has been addressed in the following products:

  Red Hat Enterprise Linux 6

Via RHSA-2017:1759 https://access.redhat.com/errata/RHSA-2017:1759

Comment 12 errata-xmlrpc 2017-08-01 23:25:00 UTC
This issue has been addressed in the following products:

  Red Hat Enterprise Linux 7

Via RHSA-2017:2389 https://access.redhat.com/errata/RHSA-2017:2389

Comment 13 Dhiru Kholia 2017-08-02 09:47:53 UTC
External References:

http://freeradius.org/security/fuzzer-2017.html


Note You need to log in before you can comment on or make changes to this bug.